/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.commands
{
	import mx.collections.ArrayCollection;
	import mx.collections.ListCollectionView;
	import mx.controls.Alert;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.QueryResult;
	import org.ow2.sirocco.cloudmanager.ui.events.ListCloudProviderAccountEvent;
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.ICloudProviderService;
	
	public class ListCloudProviderAccountCommand
	{
		[Inject]
		public var providerService:ICloudProviderService;
		
		[Inject]
		public var model:Model;
		
		public function execute (query:ListCloudProviderAccountEvent): AsyncToken {
			return providerService.listCloudProviderAccountsByUser(query.user);
		}
		
		public function result (items:ListCollectionView): void {
			model.cloudProviderAccountCache.count=items.length;
			model.cloudProviderAccountCache.items.removeAll();
			model.cloudProviderAccountCache.items.addAll(items);
		}
		
		public function error (fault: Fault): void {
			Alert.show("ERROR "+fault.faultCode+" "+fault.faultDetail);
		}
	}
}