/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.commands
{
	import mx.collections.ArrayCollection;
	import mx.controls.Alert;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.Job;
	import org.ow2.sirocco.cloudmanager.model.cimi.QueryResult;
	import org.ow2.sirocco.cloudmanager.ui.events.ListJobEvent;
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.IJobService;
	
	public class ListJobCommand
	{
		[Inject]
		public var jobService:IJobService;
		
		[Inject]
		public var model:Model;
		
		public function execute (query:ListJobEvent): AsyncToken {
			return jobService.listJobs(query.first,query.last);
		}
		
		public function result (query:QueryResult): void {
			var topLevelJobs:ArrayCollection=new ArrayCollection();
			for(var i:int=0;i<query.items.length;i++) {
				var job:Job=query.items[i];
				if(job.parentJob==null) topLevelJobs.addItem(job);
			}
			model.jobCache.items.removeAll();
			model.jobCache.items.addAll(topLevelJobs);
			model.jobCache.count=query.count;
		}
		
		public function error (fault: Fault): void {
			Alert.show("ERROR "+fault.faultCode);
		}
	}
}