/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.commands
{
	import flash.system.System;
	
	import mx.collections.ArrayCollection;
	import mx.controls.Alert;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.QueryResult;
	import org.ow2.sirocco.cloudmanager.model.cimi.system.SystemSystem;
	import org.ow2.sirocco.cloudmanager.ui.events.ListSystemEvent;
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.ISystemService;
	
	public class ListSystemCommand
	{
		[Inject]
		public var systemService:ISystemService;
		
		[Inject]
		public var model:Model;
		
		public function execute (query:ListSystemEvent): AsyncToken {
			return systemService.listSystems(query.first,query.last);
		}
		
		private function populateSystemTree(sys:org.ow2.sirocco.cloudmanager.model.cimi.system.System):void {
			for(var i:int=0;i<sys.systems.length;i++) {
				var ss:SystemSystem=SystemSystem(sys.systems[i]);
				var subSys:org.ow2.sirocco.cloudmanager.model.cimi.system.System=org.ow2.sirocco.cloudmanager.model.cimi.system.System(ss.resource);
				if(subSys.visited==0) {
					subSys.visited=-1;
					populateSystemTree(subSys);
				}
				else if(subSys.visited>=1) {
					model.systemCache.items.removeItemAt(subSys.visited-1);
					subSys.visited=-1;
				}
			}
		}
		
		public function result (query:QueryResult): void {
			model.systemCache.count=query.count;
			model.systemCache.items.removeAll();
			
			for(var i:int=0;i<query.items.length;i++) {
				var sys:org.ow2.sirocco.cloudmanager.model.cimi.system.System=org.ow2.sirocco.cloudmanager.model.cimi.system.System(query.items[i]);
				if(sys.visited!=0) continue;
				model.systemCache.items.addItem(sys);
				sys.visited=model.systemCache.items.length;
				populateSystemTree(sys);
			}
		}
		
		public function error (fault: Fault): void {
			Alert.show("ERROR "+fault.faultCode+" "+fault.faultDetail);
		}
	}
}