/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.commands
{
	import mx.controls.Alert;
	import mx.managers.CursorManager;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	import mx.rpc.events.FaultEvent;
	import mx.utils.ObjectProxy;
	import mx.utils.ObjectUtil;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.QueryResult;
	import org.ow2.sirocco.cloudmanager.model.cimi.extension.User;
	import org.ow2.sirocco.cloudmanager.ui.events.ListCloudProviderAccountEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListCloudProviderEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListCredentialEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListMachineConfigEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListMachineImageEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListMachineTemplateEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListSystemTemplateEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListVolumeConfigEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListVolumeEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.ListVolumeTemplateEvent;
	import org.ow2.sirocco.cloudmanager.ui.events.LoginEvent;
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.ILoginService;

	public class LoginCommand
	{
		[Inject]
		public var loginService:ILoginService;
		
		[Inject]
		public var model:Model;
		
		[MessageDispatcher]
		public var dispatcher:Function;
		
		private var callback:Function;
		
		public function execute (loginEvent:LoginEvent): AsyncToken {
			this.callback=loginEvent.callback;
			return loginService.login(loginEvent.user);
		}
		
		public function result (user: User): void {
			model.loggedInUser=user;
			model.connectionState="loggedIn";
			
			dispatcher(new ListCloudProviderAccountEvent(user));
			//FIXME
			dispatcher(new ListMachineTemplateEvent(-1,-1));
			dispatcher(new ListMachineConfigEvent(-1,-1));
			dispatcher(new ListVolumeEvent(-1,-1));
			dispatcher(new ListSystemTemplateEvent(-1,-1));
			dispatcher(new ListVolumeConfigEvent(-1,-1));
			dispatcher(new ListVolumeTemplateEvent(-1,-1));
			dispatcher(new ListMachineImageEvent(-1,-1));
			dispatcher(new ListCredentialEvent(-1,-1));
			callback(true);
		}
		
		public function error (fault: Fault): void {
			if(fault.faultCode.indexOf("InvalidCred")!=1)
			Alert.show("Invalid credentials");
			else Alert.show("Error: "+fault.faultCode);
			callback(false);
		}
	}
}