/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services
{
	import mx.rpc.AsyncToken;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.system.SystemCreate;
	import org.ow2.sirocco.cloudmanager.model.cimi.system.SystemTemplate;
	
	public interface ISystemService
	{
		function listSystems(first:int,last:int):AsyncToken;
		function listSystemTemplates(first:int,last:int):AsyncToken;
		function startSystem(id:String): AsyncToken;
		function stopSystem(id:String): AsyncToken;
		function restartSystem(id:String,force:Boolean): AsyncToken;
		function suspendSystem(id:String): AsyncToken;
		function deleteSystem(id:String): AsyncToken;
		function deleteSystemTemplate(id:String): AsyncToken;
		function createSystem(systemCreate:SystemCreate): AsyncToken;
		function createSystemTemplate(systemTemplate:SystemTemplate): AsyncToken;
	}
}