/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services
{
	import mx.rpc.AsyncToken;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.VolumeConfiguration;
	import org.ow2.sirocco.cloudmanager.model.cimi.VolumeCreate;
	import org.ow2.sirocco.cloudmanager.model.cimi.VolumeTemplate;
	
	public interface IVolumeService
	{
		function listVolumes(first:int,last:int):AsyncToken;
		function listVolumeConfigs(first:int,last:int):AsyncToken;
		function listVolumeTemplates(first:int,last:int):AsyncToken;
		function createVolume(volumeCreate:VolumeCreate):AsyncToken;
		function createVolumeConfig(config:VolumeConfiguration):AsyncToken;
		function createVolumeTemplate(template:VolumeTemplate):AsyncToken;
		function deleteVolume(id:String): AsyncToken;
		function deleteVolumeConfig(id:String): AsyncToken;
		function deleteVolumeTemplate(id:String): AsyncToken;
	}
}