/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services.amf
{
	import mx.rpc.AsyncToken;
	import mx.rpc.remoting.RemoteObject;
	
	import org.ow2.sirocco.cloudmanager.ui.model.Model;
	import org.ow2.sirocco.cloudmanager.ui.services.ICredentialService;
	
	public class CredentialService implements ICredentialService
	{
		[Inject(id="credentialsManager")]
		public var service:RemoteObject;
		
		[Inject]
		public var model:Model;
		
		private var logged:Boolean=false;
		
		
		public function CredentialService()
		{
		}
		
		private function login():void {
			if(!logged) {
				service.setRemoteCredentials(model.loggedInUser.username,model.loggedInUser.password);
				logged=true;
			}
		}
		
		public function listCredentials(first:int, last:int):AsyncToken
		{
			login();
			return service.getCredentials(first,last,null,null);
		}
	}
}