/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.services.mock
{
	import mx.collections.ArrayCollection;
	import mx.rpc.AsyncToken;
	
	import org.ow2.sirocco.cloudmanager.model.cimi.Machine;
	import org.ow2.sirocco.cloudmanager.ui.services.IMachineService;
	import org.ow2.sirocco.cloudmanager.ui.utils.MockServiceUtil;
	
	public class MockMachineService implements IMachineService
	{
		private const NUM_MACHINES:int=53;
		private var machines:ArrayCollection;
		
		public function MockMachineService() 
		{
			machines=new ArrayCollection();
			for(var i:int=0;i<NUM_MACHINES;i++) 
				var machine:Machine;
				machine=new Machine();
				machine.name="machine#"+i;
				machine.description="this is machine #"+i;
				machines.addItem(machine);
		}
		
		[Inject]
		public var mockService:MockServiceUtil;
		
		public function listMachines(first:int,last:int):AsyncToken
		{
			var result:Object=new Object();
			var machineSublist:ArrayCollection=new ArrayCollection();
			if(last>machines.length) last=machines.length-1;
			for(var i:int=first;i<=last;i++) machineSublist.addItem(machines.getItemAt(i));
			result["values"]=machineSublist;
			result["counter"]=NUM_MACHINES;
			return mockService.createToken(result);
		}
	}
}