/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.utils
{
	public class ImageRegistry
	{
		private static var instance:ImageRegistry;
		
		public static function getInstance():ImageRegistry 
		{
			if(instance==null) {
				instance=new ImageRegistry();
			}
			return instance;
		}
		public function ImageRegistry()
		{
		}
		
		public function getCountryFlag(country:String):Class {
			switch(country) {
				case "France": return franceFlag;
				case "Brazil": return brazilFlag;	
				case "Ireland": return irelandFlag;
				case "Japan": return japanFlag;	
				case "Singapore": return singaporeFlag;	
				case "USA": return usaFlag;	
			}
			return null;
		}
		
		
		[Bindable]
		[Embed(source="/assets/add.png")] 
		public var addIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/poweroff.png")] 
		public var powerOffIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/poweron.png")] 
		public var powerOnIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/suspend.png")] 
		public var suspendIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/restart.png")] 
		public var restartIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/delete.png")] 
		public var deleteIcon:Class;
		
		[Bindable]
		[Embed(source="/assets/france-icon.png")] 
		public var franceFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/brazil-icon.png")] 
		public var brazilFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/ireland-icon.png")] 
		public var irelandFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/japan-icon.png")] 
		public var japanFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/singapore-icon.png")] 
		public var singaporeFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/usa-icon.png")] 
		public var usaFlag:Class;
		
		[Bindable]
		[Embed(source="/assets/ball_red.gif")] 
		public var redBall:Class;
		
		[Bindable]
		[Embed(source="/assets/ball_yellow.gif")] 
		public var yellowBall:Class;
		
		[Bindable]
		[Embed(source="/assets/ball_green.gif")] 
		public var greenBall:Class;
		
		[Bindable]
		[Embed(source="/assets/ball_gray.gif")] 
		public var grayBall:Class;
		
		[Bindable]
		[Embed(source="/assets/host.png")] 
		public var machine:Class;
		
		[Bindable]
		[Embed(source="/assets/appliance.png")] 
		public var appliance:Class;
		
		[Bindable]
		[Embed(source="/assets/job.png")] 
		public var job:Class;
		
		[Bindable]
		[Embed(source="/assets/sirocco_logo.png")] 
		public var logo:Class;
		
		[Bindable]
		[Embed(source="/assets/sirocco_small_logo.png")] 
		public var smallLogo:Class;
		
		
	}
}