/**
 *
 * SIROCCO
 * Copyright (C) 2012 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 */
package org.ow2.sirocco.cloudmanager.ui.utils
{
	import flash.events.EventDispatcher;
	import flash.utils.setTimeout;
	
	import mx.core.mx_internal;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	
	use namespace mx_internal;
	
	public class MockServiceUtil extends EventDispatcher
	{
		
		public function createToken(result:Object):AsyncToken
		{
			var token:AsyncToken = new AsyncToken(null);
			setTimeout(applyResult, Math.random()*500, token, result);
			return token;
		}
		
		private function applyResult(token:AsyncToken, result:Object):void
		{
			token.setResult(result);
			var event:ResultEvent = new ResultEvent(ResultEvent.RESULT, false, true, result, token);
			token.applyResult(event);
		}
		
		public function createErrorToken(result:Object):AsyncToken
		{
			var token:AsyncToken = new AsyncToken(null);
			setTimeout(applyErrorResult, Math.random()*500, token, result);
			return token;
		}
		
		private function applyErrorResult(token:AsyncToken, result:Object):void
		{
			var fault:Fault=new Fault("mockError","mockFault");
			var event:FaultEvent = new FaultEvent(FaultEvent.FAULT, false, true, fault, token);
			token.applyFault(event);
		}
		
	}
}
	
	
